Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.7.1 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jivesoftware.util
Class TaskEngine

    java.lang.Object
      org.jivesoftware.util.TaskEngine

    public class TaskEngine

extends Object

Performs tasks using worker threads. It also allows tasks to be scheduled to be run at future dates. This class mimics relevant methods in both `ExecutorService` and `Timer`. Any `TimerTask` that's scheduled to be run in the future will automatically be run using the thread executor's thread pool. This means that the standard restriction that TimerTasks should run quickly does not apply.

Author:
  Matt Tucker

Method Summary
`void` | `cancelScheduledTask(TimerTask task)` Cancels the execution of a scheduled task.
`static TaskEngine` | `getInstance()` Returns a task engine instance (singleton).
`void` | `schedule(TimerTask task, Date time)` Schedules the specified task for execution at the specified time.
`void` | `schedule(TimerTask task, Date firstTime, long period)` Schedules the specified task for repeated fixed-delay execution, beginning at the specified time.
`void` | `schedule(TimerTask task, long delay)` Schedules the specified task for execution after the specified delay.
`void` | `schedule(TimerTask task, long delay, long period)` Schedules the specified task for repeated fixed-delay execution, beginning after the specified delay.
`void` | `scheduleAtFixedRate(TimerTask task, Date firstTime, long period)` Schedules the specified task for repeated fixed-rate execution, beginning at the specified time.
`void` | `scheduleAtFixedRate(TimerTask task, long delay, long period)` Schedules the specified task for repeated fixed-rate execution, beginning after the specified delay.
`void` | `shutdown()` Shuts down the task engine service.
`Future<?>` | `submit(Runnable task)` Submits a Runnable task for execution and returns a Future representing that task.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### getInstance

    public static TaskEngine getInstance()

  Returns a task engine instance (singleton).

  Returns:
    a task engine.

### submit

    public Future<?> submit(Runnable task)

  Submits a Runnable task for execution and returns a Future representing that task.

  Parameters:
    `task` - the task to submit.
  Returns:
    a Future representing pending completion of the task, and whose `get()` method will return `null` upon completion.
  Throws:
    `RejectedExecutionException` - if task cannot be scheduled for execution.
    `NullPointerException` - if task null.

### schedule

    public void schedule(TimerTask task,
                         long delay)

  Schedules the specified task for execution after the specified delay.

  Parameters:
    `task` - task to be scheduled.
    `delay` - delay in milliseconds before task is to be executed.
  Throws:
    `IllegalArgumentException` - if `delay` is negative, or `delay + System.currentTimeMillis()` is negative.
    `IllegalStateException` - if task was already scheduled or cancelled, or timer was cancelled.

### schedule

    public void schedule(TimerTask task,
                         Date time)

  Schedules the specified task for execution at the specified time. If the time is in the past, the task is scheduled for immediate execution.

  Parameters:
    `task` - task to be scheduled.
    `time` - time at which task is to be executed.
  Throws:
    `IllegalArgumentException` - if `time.getTime()` is negative.
    `IllegalStateException` - if task was already scheduled or cancelled, timer was cancelled, or timer thread terminated.

### schedule

    public void schedule(TimerTask task,
                         long delay,
                         long period)

  Schedules the specified task for repeated fixed-delay execution, beginning after the specified delay. Subsequent executions take place at approximately regular intervals separated by the specified period.

  In fixed-delay execution, each execution is scheduled relative to the actual execution time of the previous execution. If an execution is delayed for any reason (such as garbage collection or other background activity), subsequent executions will be delayed as well. In the long run, the frequency of execution will generally be slightly lower than the reciprocal of the specified period (assuming the system clock underlying `Object.wait(long)` is accurate).

  Fixed-delay execution is appropriate for recurring activities that require "smoothness." In other words, it is appropriate for activities where it is more important to keep the frequency accurate in the short run than in the long run. This includes most animation tasks, such as blinking a cursor at regular intervals. It also includes tasks wherein regular activity is performed in response to human input, such as automatically repeating a character as long as a key is held down.

  Parameters:
    `task` - task to be scheduled.
    `delay` - delay in milliseconds before task is to be executed.
    `period` - time in milliseconds between successive task executions.
  Throws:
    `IllegalArgumentException` - if `delay` is negative, or `delay + System.currentTimeMillis()` is negative.
    `IllegalStateException` - if task was already scheduled or cancelled, timer was cancelled, or timer thread terminated.

### schedule

    public void schedule(TimerTask task,
                         Date firstTime,
                         long period)

  Schedules the specified task for repeated fixed-delay execution, beginning at the specified time. Subsequent executions take place at approximately regular intervals, separated by the specified period.

  In fixed-delay execution, each execution is scheduled relative to the actual execution time of the previous execution. If an execution is delayed for any reason (such as garbage collection or other background activity), subsequent executions will be delayed as well. In the long run, the frequency of execution will generally be slightly lower than the reciprocal of the specified period (assuming the system clock underlying `Object.wait(long)` is accurate).

  Fixed-delay execution is appropriate for recurring activities that require "smoothness." In other words, it is appropriate for activities where it is more important to keep the frequency accurate in the short run than in the long run. This includes most animation tasks, such as blinking a cursor at regular intervals. It also includes tasks wherein regular activity is performed in response to human input, such as automatically repeating a character as long as a key is held down.

  Parameters:
    `task` - task to be scheduled.
    `firstTime` - First time at which task is to be executed.
    `period` - time in milliseconds between successive task executions.
  Throws:
    `IllegalArgumentException` - if `time.getTime()` is negative.
    `IllegalStateException` - if task was already scheduled or cancelled, timer was cancelled, or timer thread terminated.

### scheduleAtFixedRate

    public void scheduleAtFixedRate(TimerTask task,
                                    long delay,
                                    long period)

  Schedules the specified task for repeated fixed-rate execution, beginning after the specified delay. Subsequent executions take place at approximately regular intervals, separated by the specified period.

  In fixed-rate execution, each execution is scheduled relative to the scheduled execution time of the initial execution. If an execution is delayed for any reason (such as garbage collection or other background activity), two or more executions will occur in rapid succession to "catch up." In the long run, the frequency of execution will be exactly the reciprocal of the specified period (assuming the system clock underlying `Object.wait(long)` is accurate).

  Fixed-rate execution is appropriate for recurring activities that are sensitive to absolute time, such as ringing a chime every hour on the hour, or running scheduled maintenance every day at a particular time. It is also appropriate for recurring activities where the total time to perform a fixed number of executions is important, such as a countdown timer that ticks once every second for ten seconds. Finally, fixed-rate execution is appropriate for scheduling multiple repeating timer tasks that must remain synchronized with respect to one another.

  Parameters:
    `task` - task to be scheduled.
    `delay` - delay in milliseconds before task is to be executed.
    `period` - time in milliseconds between successive task executions.
  Throws:
    `IllegalArgumentException` - if `delay` is negative, or `delay + System.currentTimeMillis()` is negative.
    `IllegalStateException` - if task was already scheduled or cancelled, timer was cancelled, or timer thread terminated.

### scheduleAtFixedRate

    public void scheduleAtFixedRate(TimerTask task,
                                    Date firstTime,
                                    long period)

  Schedules the specified task for repeated fixed-rate execution, beginning at the specified time. Subsequent executions take place at approximately regular intervals, separated by the specified period.

  In fixed-rate execution, each execution is scheduled relative to the scheduled execution time of the initial execution. If an execution is delayed for any reason (such as garbage collection or other background activity), two or more executions will occur in rapid succession to "catch up." In the long run, the frequency of execution will be exactly the reciprocal of the specified period (assuming the system clock underlying `Object.wait(long)` is accurate).

  Fixed-rate execution is appropriate for recurring activities that are sensitive to absolute time, such as ringing a chime every hour on the hour, or running scheduled maintenance every day at a particular time. It is also appropriate for recurring activities where the total time to perform a fixed number of executions is important, such as a countdown timer that ticks once every second for ten seconds. Finally, fixed-rate execution is appropriate for scheduling multiple repeating timer tasks that must remain synchronized with respect to one another.

  Parameters:
    `task` - task to be scheduled.
    `firstTime` - First time at which task is to be executed.
    `period` - time in milliseconds between successive task executions.
  Throws:
    `IllegalArgumentException` - if `time.getTime()` is negative.
    `IllegalStateException` - if task was already scheduled or cancelled, timer was cancelled, or timer thread terminated.

### cancelScheduledTask

    public void cancelScheduledTask(TimerTask task)

  Cancels the execution of a scheduled task. `TimerTask.cancel()`

  Parameters:
    `task` - the scheduled task to cancel.

### shutdown

    public void shutdown()

  Shuts down the task engine service.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.7.1 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2008 Jive Software.